import es, gamethread, playerlib, popuplib, effectlib

### Start Config ###

min_players_for_lr = 2
announce_rebel_killed = 1
max_non_rebels_kill_per_round = 3
too_many_non_rebels_killed_punishment = 'takehp75' # Valid options are slay, kick, stripweapons and takehp<hp>
announce_turn_into_rebel = 1
max_innocent_kills_per_3_seconds = 3
too_high_kps_punishment = 'kick' # Same options as too many non rebels killed like, if they line up and shoot 'em
unrestricted_weapons = ['m4a1', 'deagle', 'famas', 'aug', 'tmp', 'knife']
t_start_weapons = ['deagle']
ct_start_weapons = ['m4a1', 'deagle']
beacon_on_lr = 1
allow_to_kill_for_jumping_on_head = 1 # whether or not hostages can kill for cts jumping on their head

### Classes ###

es.ServerVar('hosties_version', 1.0, 'Hosties Server Control by Bonbon').makepublic()

class LastRequest(object):

	def __init__(self):
		self.players = {}
		self.lastrequest = False
		self.t = None
		self.ct = None
		self.lrwinner = None

	def can_lr(self, userid):
		if playerlib.getPlayer(userid).get('isdead'):
			es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultYou have to be alive to use this feature!')
			return

		if not es.getplayerteam(userid) == 2:
			es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultYou have to be a terrorist to use the last request!')
			return

		if not len(playerlib.getPlayerList('#t,#alive')) <= min_players_for_lr:
			es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultThere are too many Terrorists!')
			return

		if self.lastrequest:
			es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultThere is already a last request in progress!')
			return
		return True

	def initiate_request(self, userid):
		if self.can_lr(userid):
			popuplib.send('Last Request', userid)

	def S4S(self):
		es.msg('#multi', '#lightgreen[Hosties]: %s#default has chosen to have shot for shot with #lightgreen%s'%(es.getplayername(self.t), es.getplayername(self.ct)))
		playerlib.getPlayer(self.t).set('health', 100)
		playerlib.getPlayer(self.ct).set('health', 100)
		es.server.queuecmd('es_xgive %s weapon_deagle;es_xgive %s weapon_deagle'%(self.t, self.ct))
		self.beacon(self.t)
		self.beacon(self.ct)
		es.msg('#multi', '#lightgreen[Hosties]: #defaultThe two S4S contestants are beaconed, find a place to play S4S!')
		self.lastrequest = 'S4S'

	def GT(self):
		es.msg('#multi', '#lightgreen[Hosties]: %s#default has chosen to have a gun toss with #lightgreen%s!'%(es.getplayername(self.t), es.getplayername(self.ct)))
		self.beacon(self.t)
		self.beacon(self.ct)
		es.server.queuecmd('es_xgive %s weapon_deagle;es_xgive %s weapon_deagle'%(self.t, self.ct))
		es.msg('#multi', '#lightgreen[Hosties]: #defaultThe object of the game is to throw the deagle farther than the other player!')
		self.lrwinner = self.t
		

	def CF(self):
		es.msg('#multi', '#lightgreen[Hosties]: %s#default has chosen to have a chicken fight with #lightgreen%s'%(es.getplayername(self.t), es.getplayername(self.ct)))
		es.msg('#multi', '#lightgreen[Hosties]: #defaultThe object of the game is to get on the other players head!')
		es.msg('#multi', '#lightgreen[Hosties]: #defaultThe coding to check for people on head is not perfect, so don\'t always rely on it!')
		self.beacon(self.t)
		self.beacon(self.ct)

	def KF(self):
		es.msg('#multi', '#lightgreen[Hosties]: %s#default has chosen to have a knife fight with #lightgreen%s'%(es.getplayername(self.t), es.getplayername(self.ct)))
		playerlib.getPlayer(self.t).set('health', 100)
		playerlib.getPlayer(self.ct).set('health', 100)
		for userid in [self.t, self.ct]:
			es.server.queuecmd('es_xgive %s player_weaponstrip'%userid)
			es.server.queucmd('es_xfire %s player_weaponstrip strip'%userid)
			es.server.queuecmd('es_xgive %s weapon_knife'%userid)
			self.beacon(userid)
		es.server.queuecmd('es_xfire %s player_weaponstrip kill'%userid)
		es.msg('#multi', '#lightgreen[Hosties]: #defaultPlayers are beaconed, you may fight!')

	def check_chicken_won(self, userid):
		if self.lastrequest == 'CF':
			if userid in [self.t, self.ct]:
				if playerlib.getPlayer(self.t).get('distance', [self.ct, 'xy']) <= 40 and 180 >= playerlib.getPlayer(self.t).get('distance', [self.ct, 'z']) >= 60:
					es.msg('#multi', '#lightgreen[Hosties]: %s#default has lost the chicken fight!'%es.getplayername(self.ct))
					self.lrwinner = self.ct
					self.lastrequest = False
				elif playerlib.getPlayer(self.t).get('distance', [self.ct, 'xy']) <= 40 and 180 >= playerlib.getPlayer(self.ct).get('distance', [self.t, 'z']) >= 60:
					es.msg('#multi', '#lightgreen[Hosties]: %s#default has lost the chicken fight!'%es.getplayername(self.t))
					self.lastrequest = False
				if not self.lastrequest:
					gamethread.cancelDelayed('beacon_%s'%self.t)
					gamethread.cancelDelayed('beacon_%s'%self.ct)

	def check_lr_won(self, userid, attacker, weapon):
		if self.lastrequest:
			if self.lastrequest == 'S4S':
				if userid in [self.t, self.ct] or attacker in [self.t, self.ct]:
					if not userid in [self.t, self.ct] or not attacker in [self.t, self.ct]:
						if userid == self.t:
							if not userid in Rb.rebels:
								es.msg('#multi', '#lightgreen[Hosties]: %s #defaulthas been killed by another CT!')
								playerlib.getPlayer(attacker).set('health', 25)
								self.lastrequest = False
								return
						es.msg('#multi', '#lightgreen[Hosties]: %s #defaultis rebelling!'%es.getplayername(attacker))
						Rb.rebels.append(attacker)
						self.lastrequest = False
						return
					es.msg('#multi', '#lightgreen[Hosties]: %s #defaultwon the Shot for Shot!'%es.getplayername(attacker))
					self.lrwinner = attacker
					self.lastrequest = False
					gamethread.cancelDelayed('beacon_%s'%self.t)
					gamethread.cancelDelayed('beacon_%s'%self.ct)
			elif self.lastrequest == 'KF':
				if weapon == 'knife':
					if attacker == self.t:
						if userid == self.ct:
							es.msg('#multi', '#lightgreen[Hosties]: %s#default has won the Knife Fight!'%es.getplayername(attacker))
							self.lastrequest = False
							self.lrwinner = attacker
							return
						es.msg('#multi', '#lightgreen[Hosties]: %s#default is rebelling!'%es.getplayername(attacker))
						self.lastrequest = False
						Rb.rebels.append(attacker)
					elif attacker == self.ct:
						if userid == self.t:
							es.msg('#multi', '#lightgreen[Hosties]: %s #defaulthas won the Knife Fight!'%es.getplayername(attacker))
							self.lastrequest = False
				else:
					if attacker == self.t:
						es.msg('#multi', '#lightgreen[Hosties]: %s#default is rebelling!'%es.getplayername(self.t))
					elif attacker == self.ct:
						es.msg('#multi', '#lightgreen[Hosties]: %s#default used a gun in a knife fight!'%es.getplayername(self.ct))

	def beacon(self, userid):
		if not playerlib.getPlayer(userid).get('isdead'):
			if beacon_on_lr:
				gamethread.cancelDelayed('beacon_%s'%userid)
				gamethread.delayedname(1, 'beacon_%s'%userid, self.beacon, userid)
				x, y, z = es.getplayerlocation(userid)
				es.server.queuecmd('est_effect 10 %s 0 "sprites/lgtning.vmt" %s %s %s 20 300 0.2 20 10 0 255 0 0 255 30'%(userid, x, y, z))
				es.server.queuecmd('est_effect 10 %s 0.1 "sprites/lgtning.vmt" %s %s %s 20 300 0.3 15 10 0 255 150 150 255 30'%(userid, x, y, z))
				es.emitsound('player', userid, 'buttons/blip2.wav', 1.0, 0.7)

LR = LastRequest()
lrfuncs = {
	'Shot For Shot': LR.S4S,
	'Gun Toss': LR.GT,
	'Chicken Fight': LR.CF,
	'Knife Fight': LR.KF
}

class Rebel(object):

	def __init__(self):
		self.rebels = []
		self.ik = {}
		self.rebelchange = {}
		self.kps = {}
		self.on_heads = {}

	def player_death(self, userid, attacker, weapon):
		if es.getplayerteam(attacker) == 2:
			if attacker in self.on_heads:
				if self.on_heads[attacker] == userid:
					del self.on_heads[attacker]
					if weapon == 'knife':
						es.msg('#multi', '#lightgreen[Hosties]: %s#default killed #lightgreen%s#default for previously jumping on his/her head!'%(es.getplayername(attacker), es.getplayername(userid)))
						es.msg('#multi', '#lightgreen[Hosties]: #defaultDo NOT kill #lightgreen%s!'%es.getplayername(attacker))
						return
			if not attacker == LR.lrwinner:
				if announce_turn_into_rebel:
					if not attacker in self.rebels:
						es.msg('#multi', '#lightgreen[Hosties]: %s#default is now a rebel!'%es.getplayername(attacker))
				self.rebels.append(attacker)
			else:
				LR.lrwinner = None
		self.check_rebel(userid)
		if userid in self.rebels:
			if announce_rebel_killed:
				es.msg('#multi', '#lightgreen[Hosties]: %s #defaultkilled a rebel!'%es.getplayername(attacker))
		if not userid in self.rebels:
			self.ik[attacker] = self.ik[attacker] + 1 if attacker in self.ik else 1
			if self.ik[attacker] >= max_non_rebels_kill_per_round:
				self.punish(attacker, too_many_non_rebels_killed_punishment)

	def punish(self, userid, o):
		if o == 'slay':
			playerlib.getPlayer(userid).set('health', 0)
			es.server.queuecmd('es_xfire %s !self ignite'%userid)
		elif o == 'kick':
			es.server.queuecmd('kickid %s Don\'t line up and kill hosties!'%userid)
		elif o.startswith('takehp'):
			playerlib.getPlayer(userid).set('health', max(playerlib.getPlayer(userid).get('health') - int(o[6:]), 1))
		elif o == 'stripweapons':
			es.server.queuecmd('es_xgive %s player_weaponstrip'%userid)
			es.server.queuecmd('es_xfire %s player_weaponstrip strip'%userid)
			es.server.queuecmd('es_xfire %s player_weaponstrip kill'%userid)
		es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultDo not kill too many innocent hostages!')

	def make_0(self, userid):
		self.kps[userid] = 0

	def check_rebel(self, userid):
		if es.getplayerteam(userid) == 2:
			if not playerlib.getPlayer(userid).get('primary') == '0':
				self.rebels.append(userid)
			elif not playerlib.getPlayer(userid).get('primary') == '0':
				self.rebels.append(userid)

	def check_on_head(self, userid):
		if allow_to_kill_for_jumping_on_head:
			if es.getplayerteam(userid) == 3:
				for userid2 in playerlib.getUseridList('#t'):
					if playerlib.getPlayer(userid).get('distance', [userid2, 'xy']) <= 40 and 180 >= playerlib.getPlayer(userid).get('distance', [userid2, 'z']) >= 60:
						self.on_heads[userid2] = userid
						break

Rb = Rebel()

### Loads ###

def load():
	lrmenu = popuplib.easymenu('Last Request', '_popup_choice', lrmenu_select)
	for option in ['Shot For Shot', 'Gun Toss', 'Chicken Fight', 'Knife Fight']:
		lrmenu.addoption(option, option)
	es.addons.registerClientCommandFilter(_restrict_weapons)

def unload():
	es.addons.unregisterClientCommandFilter(_restrict_weapons)

### Commands ###

def lastrequest():
	LR.initiate_request(es.getuserid())

### Events ###

def player_say(ev):
	if ev['text'].lower() == '!lr':
		LR.initiate_request(int(ev['userid']))

def player_death(ev):
	LR.check_lr_won(int(ev['userid']), int(ev['attacker']), ev['weapon'])
	Rb.player_death(int(ev['userid']), int(ev['attacker']), ev['weapon'])

def player_jump(ev):
	gamethread.delayed(0.3, LR.check_chicken_won, int(ev['userid']))
	gamethread.delayed(0.3, Rb.check_on_head, int(ev['userid']))

def round_end(ev):
	LR.lastrequest = False
	Rb.rebels = []
	Rb.ik.clear()
	LR.lrwinner = None
	Rb.on_heads.clear()
	for userid in es.getUseridList():
		gamethread.cancelDelayed('beacon_%s'%userid)

def player_disconnect(ev):
	u = int(ev['userid'])
	if u in Rb.kps:
		del Rb.kps[u]
	if u in Rb.ik:
		del Rb.ik[u]

def item_pickup(ev):
	if not ev['item'] in unrestricted_weapons:
		handle = es.getplayerhandle(ev['userid'])
		for index in es.createentitylist('weapon_%s'%ev['item']):
			if handle == es.getindexprop(index, "CBaseEntity.m_hOwnerEntity"):
				es.server.queuecmd('es_xremove %s'%index)
				es.tell(ev['userid'], '#multi', '#lightgreen[Hosties]: #defaultSorry, the #lightgreen%s#default is restricted'%ev['item'])
				es.cexec(ev['userid'], 'lastinv')
				break

def player_spawn(ev):
	if es.getplayerteam(ev['userid']) == 2:
		for weapon in t_start_weapons:
			es.server.queuecmd('es_xgive %s weapon_%s'%(ev['userid'], weapon))
	elif es.getplayerteam(ev['userid']) == 3:
		for weapon in ct_start_weapons:
			es.server.queuecmd('es_xgive %s weapon_%s'%(ev['userid'], weapon))

### Popup Selects ###

def lrmenu_select(userid, choice, popupid):
	if LR.can_lr(userid):
		choseplayer = popuplib.easymenu('Chose Player', '_popup_choice', choseplayer_select)
		for userid2 in playerlib.getUseridList('#ct'):
			choseplayer.addoption([choice, userid2], es.getplayername(userid2))
		popuplib.send('Chose Player', userid)

def choseplayer_select(userid, choice, popupid):
	if not es.exists('userid', choice[1]):
		es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultTarget has left the server!')
		return

	if playerlib.getPlayer(choice[1]).get('isdead'):
		es.tell(userid, '#multi', '#lightgreen[Hosties]: #defaultTarget is now dead!')
		return

	if LR.can_lr(userid):
		LR.t = userid
		LR.ct = choice[1]
		LR.lastrequest = {'Shot For Shot': 'S4S', 'Gun Toss': 'GT', 'Chicken Fight': 'CF', 'Knife Fight': 'KF'}[choice[0]]
		lrfuncs[choice[0]]()

### Misc ###

def _restrict_weapons(userid, args):
	if args[0].lower() == 'buy':
		if not args[0].lower() in unrestricted_weapons:
			return False
	return True

